package stocks.client;

import stocks.StockInfo;

public class ClientStockImpl implements ClientStock {
  String name;
  String symbol;
  String ISIN;
  int stockType;
  long high;
  long low;
  long last;
  
  public ClientStockImpl( StockInfo info ) {
    name = info.name;
    symbol = info.symbol;
    ISIN = info.ISIN;
    if( info.type == stocks.StockInfoPackage.StockType.common_stock )
      stockType = common_stock;
    else if( info.type == stocks.StockInfoPackage.StockType.common_stock )
      stockType = preferred_stock;
    else if( info.type == stocks.StockInfoPackage.StockType.tresury_stock )
      stockType = tresury_stock;
    high = info.quote.high;
    low = info.quote.low;
    last = info.quote.last;
  }

  public String getName() {
    return( name );
  }

  public String getSymbol() {
    return( symbol );
  }

  public String getISIN() {
    return( ISIN );
  }

  public int getStockType() {
    return( stockType );
  }

  public long getHigh() {
    return( high );
  }

  public long getLow() {
    return( low );
  }

  public long getLast() {
    return( last );
  }
}
