package stocks.client;

import stocks.*;

public class ClientStockQuoterImpl implements ClientStockQuoter {
  StockQuoter _quoter = null; 

	public ClientStockQuoterImpl( StockQuoter quoter ) {
    _quoter = quoter;
  }

  public String getQuoterName() {
    return( _quoter.quoter_name() );
  }

  public ClientStock getStock(String stock_name) throws InvalidStockException {
    StockInfo info = null;
    
    try {
      info = _quoter.get_stock_info(stock_name);
    }
    catch( InvalidStock e ) {
      throw new InvalidStockException();
    }
    
    return( new ClientStockImpl( info ) );
  }

}
