#include "StockQuoterImpl.h"

using namespace std;
using namespace stocks;

StockQuoterImpl::StockQuoterImpl( const std::string& a_sName ) :
  QuoterImpl( a_sName )
{
}

StockQuoterImpl::~StockQuoterImpl()
{
}

::stocks::StockInfo* 
StockQuoterImpl::get_stock_info( const char* stock_name )
{
  StockInfo* l_pInfo = new StockInfo();
  string l_sName( stock_name );
  
  if( l_sName == "3M" )
  {
    l_pInfo->name        = CORBA::string_dup("3M");
    l_pInfo->symbol      = CORBA::string_dup("MMM");
    l_pInfo->ISIN        = CORBA::string_dup("US88579Y1010");
    l_pInfo->type        = StockInfo::common_stock;
    l_pInfo->quote.high  = 75;
    l_pInfo->quote.low   = 69;
    l_pInfo->quote.last  = 71;
    return( l_pInfo );
  }
  else if( l_sName == "Boeing" )
  {
    l_pInfo->name        = CORBA::string_dup("Boeing");
    l_pInfo->symbol      = CORBA::string_dup("BA");
    l_pInfo->ISIN        = CORBA::string_dup("US0970231058");
    l_pInfo->type        = StockInfo::common_stock;
    l_pInfo->quote.high  = 68;
    l_pInfo->quote.low   = 64;
    l_pInfo->quote.last  = 67;
    return( l_pInfo );
  }
  else if( l_sName == "Hewlett-Packard" ) 
  {
    l_pInfo->name        = CORBA::string_dup("Hewlett-Packard");
    l_pInfo->symbol      = CORBA::string_dup("HPQ");
    l_pInfo->ISIN        = CORBA::string_dup("US4282361033");
    l_pInfo->type        = StockInfo::preferred_stock;
    l_pInfo->quote.high  = 31;
    l_pInfo->quote.low   = 31;
    l_pInfo->quote.last  = 31;
    return( l_pInfo );
  }
  else if( l_sName == "Intel" )
  {
    l_pInfo->name        = CORBA::string_dup("Intel");
    l_pInfo->symbol      = CORBA::string_dup("INTC");
    l_pInfo->ISIN        = CORBA::string_dup("US4581401001");
    l_pInfo->type        = StockInfo::tresury_stock;
    l_pInfo->quote.high  = 29;
    l_pInfo->quote.low   = 27;
    l_pInfo->quote.last  = 27;
    return( l_pInfo );
  }

  throw InvalidStock();
  return( NULL );
}
