#include "stocks.h"
#include "QuoterFactoryImpl.h"
#include <iostream>
#include <fstream>

using namespace std;
using namespace stocks;

int main(int argc, char** argv)
{
  try {
    // Initialize orb
    CORBA::ORB_var orb = CORBA::ORB_init(argc, argv);

    // Get reference to Root POA.
    CORBA::Object_var obj
      = orb->resolve_initial_references("RootPOA");
    PortableServer::POA_var poa
      = PortableServer::POA::_narrow(obj);
      
    // Activate POA manager
    PortableServer::POAManager_var mgr
      = poa->the_POAManager();
    mgr->activate();
  
    // Create an object
    QuoterFactoryImpl l_servant;

    // Write its stringified reference to stdout
    QuoterFactory_var l_object = l_servant._this();
    
    // Put the ior into a file
    fstream fout("quoter_factory.ior", ios_base::out | ios_base::trunc );
    CORBA::String_var str = orb->object_to_string(l_object);
    fout << str << endl;
    fout.close();
    cout << str << endl;

    // Accept requests
    orb->run();
  }
  catch (const CORBA::Exception &) 
  {
    cerr << "Uncaught CORBA exception" << endl;
    return( 1 );
  }
  
  return( 0 );
}
