/*
 *  MICO --- an Open Source CORBA implementation
 *  Copyright (c) 1997-2003 by The Mico Team
 *
 *  This file was automatically generated. DO NOT EDIT!
 */

#include <CORBA.h>
#include <mico/throw.h>

#ifndef __STOCKS_H__
#define __STOCKS_H__






namespace stocks
{

class Quoter;
typedef Quoter *Quoter_ptr;
typedef Quoter_ptr QuoterRef;
typedef ObjVar< Quoter > Quoter_var;
typedef ObjOut< Quoter > Quoter_out;

class StockQuoter;
typedef StockQuoter *StockQuoter_ptr;
typedef StockQuoter_ptr StockQuoterRef;
typedef ObjVar< StockQuoter > StockQuoter_var;
typedef ObjOut< StockQuoter > StockQuoter_out;

class QuoterFactory;
typedef QuoterFactory *QuoterFactory_ptr;
typedef QuoterFactory_ptr QuoterFactoryRef;
typedef ObjVar< QuoterFactory > QuoterFactory_var;
typedef ObjOut< QuoterFactory > QuoterFactory_out;

}






namespace stocks
{

struct StockInfo;
typedef TVarVar< StockInfo > StockInfo_var;
typedef TVarOut< StockInfo > StockInfo_out;


struct StockInfo {
  #ifdef HAVE_TYPEDEF_OVERLOAD
  typedef StockInfo_var _var_type;
  #endif
  enum StockType {
    common_stock = 0,
    preferred_stock,
    tresury_stock
  };

  typedef StockType& StockType_out;

  struct StockQuote;
  typedef TFixVar< StockQuote > StockQuote_var;
  typedef StockQuote& StockQuote_out;


  struct StockQuote {
    #ifdef HAVE_TYPEDEF_OVERLOAD
    typedef StockQuote_var _var_type;
    #endif
    #ifdef HAVE_EXPLICIT_STRUCT_OPS
    StockQuote();
    ~StockQuote();
    StockQuote( const StockQuote& s );
    StockQuote& operator=( const StockQuote& s );
    #endif //HAVE_EXPLICIT_STRUCT_OPS

    CORBA::Long high;
    CORBA::Long low;
    CORBA::Long last;
  };

  #ifdef HAVE_EXPLICIT_STRUCT_OPS
  StockInfo();
  ~StockInfo();
  StockInfo( const StockInfo& s );
  StockInfo& operator=( const StockInfo& s );
  #endif //HAVE_EXPLICIT_STRUCT_OPS

  CORBA::String_var name;
  CORBA::String_var symbol;
  CORBA::String_var ISIN;
  StockInfo::StockType type;
  StockInfo::StockQuote quote;
};

struct InvalidStock : public CORBA::UserException {
  #ifdef HAVE_EXPLICIT_STRUCT_OPS
  InvalidStock();
  ~InvalidStock();
  InvalidStock( const InvalidStock& s );
  InvalidStock& operator=( const InvalidStock& s );
  #endif //HAVE_EXPLICIT_STRUCT_OPS


  #ifdef HAVE_STD_EH
  InvalidStock *operator->() { return this; }
  InvalidStock& operator*() { return *this; }
  operator InvalidStock*() { return this; }
  #endif // HAVE_STD_EH

  void _throwit() const;
  const char *_repoid() const;
  void _encode( CORBA::DataEncoder &en ) const;
  void _encode_any( CORBA::Any &a ) const;
  CORBA::Exception *_clone() const;
  static InvalidStock *_downcast( CORBA::Exception *ex );
  static const InvalidStock *_downcast( const CORBA::Exception *ex );
};

#ifdef HAVE_STD_EH
typedef InvalidStock InvalidStock_catch;
#else
typedef ExceptVar< InvalidStock > InvalidStock_var;
typedef TVarOut< InvalidStock > InvalidStock_out;
typedef InvalidStock_var InvalidStock_catch;
#endif // HAVE_STD_EH

struct InvalidQuoter : public CORBA::UserException {
  #ifdef HAVE_EXPLICIT_STRUCT_OPS
  InvalidQuoter();
  ~InvalidQuoter();
  InvalidQuoter( const InvalidQuoter& s );
  InvalidQuoter& operator=( const InvalidQuoter& s );
  #endif //HAVE_EXPLICIT_STRUCT_OPS


  #ifdef HAVE_STD_EH
  InvalidQuoter *operator->() { return this; }
  InvalidQuoter& operator*() { return *this; }
  operator InvalidQuoter*() { return this; }
  #endif // HAVE_STD_EH

  void _throwit() const;
  const char *_repoid() const;
  void _encode( CORBA::DataEncoder &en ) const;
  void _encode_any( CORBA::Any &a ) const;
  CORBA::Exception *_clone() const;
  static InvalidQuoter *_downcast( CORBA::Exception *ex );
  static const InvalidQuoter *_downcast( const CORBA::Exception *ex );
};

#ifdef HAVE_STD_EH
typedef InvalidQuoter InvalidQuoter_catch;
#else
typedef ExceptVar< InvalidQuoter > InvalidQuoter_var;
typedef TVarOut< InvalidQuoter > InvalidQuoter_out;
typedef InvalidQuoter_var InvalidQuoter_catch;
#endif // HAVE_STD_EH


/*
 * Base class and common definitions for interface Quoter
 */

class Quoter : 
  virtual public CORBA::Object
{
  public:
    virtual ~Quoter();

    #ifdef HAVE_TYPEDEF_OVERLOAD
    typedef Quoter_ptr _ptr_type;
    typedef Quoter_var _var_type;
    #endif

    static Quoter_ptr _narrow( CORBA::Object_ptr obj );
    static Quoter_ptr _narrow( CORBA::AbstractBase_ptr obj );
    static Quoter_ptr _duplicate( Quoter_ptr _obj )
    {
      CORBA::Object::_duplicate (_obj);
      return _obj;
    }

    static Quoter_ptr _nil()
    {
      return 0;
    }

    virtual void *_narrow_helper( const char *repoid );

    virtual char* quoter_name() = 0;

    virtual CORBA::Long get_quote( const char* stock_name ) = 0;

  protected:
    Quoter() {};
  private:
    Quoter( const Quoter& );
    void operator=( const Quoter& );
};

// Stub for interface Quoter
class Quoter_stub:
  virtual public Quoter
{
  public:
    virtual ~Quoter_stub();
    char* quoter_name();

    CORBA::Long get_quote( const char* stock_name );

  private:
    void operator=( const Quoter_stub& );
};


/*
 * Base class and common definitions for interface StockQuoter
 */

class StockQuoter : 
  virtual public ::stocks::Quoter
{
  public:
    virtual ~StockQuoter();

    #ifdef HAVE_TYPEDEF_OVERLOAD
    typedef StockQuoter_ptr _ptr_type;
    typedef StockQuoter_var _var_type;
    #endif

    static StockQuoter_ptr _narrow( CORBA::Object_ptr obj );
    static StockQuoter_ptr _narrow( CORBA::AbstractBase_ptr obj );
    static StockQuoter_ptr _duplicate( StockQuoter_ptr _obj )
    {
      CORBA::Object::_duplicate (_obj);
      return _obj;
    }

    static StockQuoter_ptr _nil()
    {
      return 0;
    }

    virtual void *_narrow_helper( const char *repoid );

    virtual StockInfo* get_stock_info( const char* stock_name ) = 0;

  protected:
    StockQuoter() {};
  private:
    StockQuoter( const StockQuoter& );
    void operator=( const StockQuoter& );
};

// Stub for interface StockQuoter
class StockQuoter_stub:
  virtual public StockQuoter,
  virtual public ::stocks::Quoter_stub
{
  public:
    virtual ~StockQuoter_stub();
    StockInfo* get_stock_info( const char* stock_name );

  private:
    void operator=( const StockQuoter_stub& );
};


/*
 * Base class and common definitions for interface QuoterFactory
 */

class QuoterFactory : 
  virtual public CORBA::Object
{
  public:
    virtual ~QuoterFactory();

    #ifdef HAVE_TYPEDEF_OVERLOAD
    typedef QuoterFactory_ptr _ptr_type;
    typedef QuoterFactory_var _var_type;
    #endif

    static QuoterFactory_ptr _narrow( CORBA::Object_ptr obj );
    static QuoterFactory_ptr _narrow( CORBA::AbstractBase_ptr obj );
    static QuoterFactory_ptr _duplicate( QuoterFactory_ptr _obj )
    {
      CORBA::Object::_duplicate (_obj);
      return _obj;
    }

    static QuoterFactory_ptr _nil()
    {
      return 0;
    }

    virtual void *_narrow_helper( const char *repoid );

    virtual Quoter_ptr create_quoter( const char* name ) = 0;

  protected:
    QuoterFactory() {};
  private:
    QuoterFactory( const QuoterFactory& );
    void operator=( const QuoterFactory& );
};

// Stub for interface QuoterFactory
class QuoterFactory_stub:
  virtual public QuoterFactory
{
  public:
    virtual ~QuoterFactory_stub();
    Quoter_ptr create_quoter( const char* name );

  private:
    void operator=( const QuoterFactory_stub& );
};

}


#ifndef MICO_CONF_NO_POA



namespace POA_stocks
{

class Quoter : virtual public PortableServer::StaticImplementation
{
  public:
    virtual ~Quoter ();
    stocks::Quoter_ptr _this ();
    bool dispatch (CORBA::StaticServerRequest_ptr);
    virtual void invoke (CORBA::StaticServerRequest_ptr);
    virtual CORBA::Boolean _is_a (const char *);
    virtual CORBA::InterfaceDef_ptr _get_interface ();
    virtual CORBA::RepositoryId _primary_interface (const PortableServer::ObjectId &, PortableServer::POA_ptr);

    virtual void * _narrow_helper (const char *);
    static Quoter * _narrow (PortableServer::Servant);

    virtual char* quoter_name() = 0;

    virtual CORBA::Long get_quote( const char* stock_name ) = 0;

  protected:
    Quoter () {};

  private:
    Quoter (const Quoter &);
    void operator= (const Quoter &);
};

class StockQuoter : 
  virtual public POA_stocks::Quoter
{
  public:
    virtual ~StockQuoter ();
    stocks::StockQuoter_ptr _this ();
    bool dispatch (CORBA::StaticServerRequest_ptr);
    virtual void invoke (CORBA::StaticServerRequest_ptr);
    virtual CORBA::Boolean _is_a (const char *);
    virtual CORBA::InterfaceDef_ptr _get_interface ();
    virtual CORBA::RepositoryId _primary_interface (const PortableServer::ObjectId &, PortableServer::POA_ptr);

    virtual void * _narrow_helper (const char *);
    static StockQuoter * _narrow (PortableServer::Servant);

    virtual ::stocks::StockInfo* get_stock_info( const char* stock_name ) = 0;

  protected:
    StockQuoter () {};

  private:
    StockQuoter (const StockQuoter &);
    void operator= (const StockQuoter &);
};

class QuoterFactory : virtual public PortableServer::StaticImplementation
{
  public:
    virtual ~QuoterFactory ();
    stocks::QuoterFactory_ptr _this ();
    bool dispatch (CORBA::StaticServerRequest_ptr);
    virtual void invoke (CORBA::StaticServerRequest_ptr);
    virtual CORBA::Boolean _is_a (const char *);
    virtual CORBA::InterfaceDef_ptr _get_interface ();
    virtual CORBA::RepositoryId _primary_interface (const PortableServer::ObjectId &, PortableServer::POA_ptr);

    virtual void * _narrow_helper (const char *);
    static QuoterFactory * _narrow (PortableServer::Servant);

    virtual ::stocks::Quoter_ptr create_quoter( const char* name ) = 0;

  protected:
    QuoterFactory () {};

  private:
    QuoterFactory (const QuoterFactory &);
    void operator= (const QuoterFactory &);
};

}


#endif // MICO_CONF_NO_POA

extern CORBA::StaticTypeInfo *_marshaller_stocks_StockInfo_StockType;

extern CORBA::StaticTypeInfo *_marshaller_stocks_StockInfo_StockQuote;

extern CORBA::StaticTypeInfo *_marshaller_stocks_StockInfo;

extern CORBA::StaticTypeInfo *_marshaller_stocks_InvalidStock;

extern CORBA::StaticTypeInfo *_marshaller_stocks_InvalidQuoter;

extern CORBA::StaticTypeInfo *_marshaller_stocks_Quoter;

extern CORBA::StaticTypeInfo *_marshaller_stocks_StockQuoter;

extern CORBA::StaticTypeInfo *_marshaller_stocks_QuoterFactory;

#endif
